﻿; заставка

.include "Vars.asm"

SplUnused       = 440   ; не используется
SplTmp1         = 446   ; буфер 4 байта используется в заставке, чтобы прорисовать почву
SplTmp2         = 450   ; а так же при динамических спецэффектах в заставке

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

EntryPoint:     mov     #EntryPoint, @#4
                mov     #TopStack, SP   ; Инициализация стека
                clr     @#MusicOff
                mov     #100, @#177660  ; Запрещаем прерывания от клавиатуры
                mov     #1330, @#177664 ; Инициализация скролла
                clr     @#SplUnused
                mov     #NoCoProgrSpl, R5 ; Сопрограммы нет
                call    @#DrawGameName  ; очистка экрана и вывод названия игры и имя автора
; ───────────────────────────────────────────────────────────────────────────
; растянем название в высоту
                mov     #21, R0
                mov     #GameNameScr1, R1 ; адрес источник
                mov     #73200, R2      ; адрес приёмник

1$:             mov     R1, R3
                sub     R2, R3
                mov     R2, R4

2$:             movb    100(R4), (R4)+
                sob     R3, 2$
                add     #100, R1
                sob     R0, 1$          ; растягивание в высоту
; ───────────────────────────────────────────────────────────────────────────
; теперь выведем бэкграунд
                clr     @#SplTmp2
                mov     #56100, R0      ; адрес начала
                clr     R1
                mov     #SplTmp1, R4
                mov     #4, R2
                mov     #BackgroundSplash, R3 ; ПЗУ монитора БК10 используется как источник случайных данных

3$:             mov     #20, R5

4$:             mov     R5, -(SP)
                mov     R1, -(SP)
                mov     #2, R1

5$:             movb    (R3)+, R5
                bic     #177600, R5
                beq     5$

6$:             cmp     R5, R2          ; R5 = R5 % R2
                ble     7$
                sub     R2, R5
                br      6$

7$:             movb    R5, (R4)+
                asl     R2
                asl     R2
                sob     R1, 6$
                mov     (SP)+, R1
                tst     -(R4)
                asr     R2
                asr     R2
                asr     R2
                asr     R2
                mov     R2, -(SP)
                mov     R3, -(SP)
                mov     #24451, R3      ; битовая маска
                call    DrawFigure      ; Вход: R0 - адрес экрана
                                        ;       R1 - номер точки в байте, с которого начинается вывод
                                        ;       R3 - битовая маска
                                        ;       R4 - адрес массива данных
                mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R5
                cmp     -(R4), -(R4)
                sob     R5, 4$
                inc     R2
                cmp     #72400, R0
                bgt     3$
; ───────────────────────────────────────────────────────────────────────────
; теперь рисуем горизонтальные полосы над и под бэкграундом
                mov     #NoCoProgrSpl, R5  ; сопрограмма
                mov     #56000, R0      ; адрес верхней полосы
                mov     #40, R1

8$:             mov     #-1, 14700(R0)  ; нижняя полоса красная
                mov     #^B1101011011010110, (R0)+ ; верхняя полоса - вот такая пёстрая
                sob     R1, 8$
; ───────────────────────────────────────────────────────────────────────────
; рисуем ствол пальмы
                mov     #PalmBodyCoords, R5 ; Координаты ствола пальмы
                mov     #47660, R0
                clr     R1
                clr     R3

9$:             mov     #PalmBodySection, R4 ; секция ствола пальмы
                movb    (R5)+, R2       ; берём смещение координат ствола пальмы
                beq     10$             ; 0 - конец вывода
                mov     R5, -(SP)
                call    DrawFigure$2    ; Вход: R0 - адрес экрана
                                        ;       R1 - номер точки в байте, с которого начинается вывод
                                        ;       R2 - биты 7..2 - смещение к адресу в R0, биты 1..0 - приращение к R1
                                        ;       R3 - битовая маска
                                        ;       R4 - адрес массива данных
                add     #100, R0
                mov     (SP)+, R5
                br      9$
; ───────────────────────────────────────────────────────────────────────────
; рисуем крону пальмы

10$:            mov     #42554, R0
                mov     #3, R1
                mov     #125252, R3
                mov     #PalmCrown, R4  ; Крона пальмы
                call    DrawFigure      ; Вход: R0 - адрес экрана
                                        ;       R1 - номер точки в байте, с которого начинается вывод
                                        ;       R3 - битовая маска
                                        ;       R4 - адрес массива данных
; ───────────────────────────────────────────────────────────────────────────
; рисуем кокосы на пальме
                mov     #45160, R0
                mov     #Kokos, R1
                mov     #14, R2

11$:            mov     (R1)+, (R0)
                add     #100, R0
                sob     R2, 11$
; ───────────────────────────────────────────────────────────────────────────
; рисуем пирамиды
                mov     #PyramidAddr, R4 ; Адреса вывода пирамид в заставке
                mov     #5, R5          ; рисуем 5 пирамидок

12$:            mov     (R4)+, R2
                call    @#DrawPyramid   ; Вход: R2 - адрес вывода
                sob     R5, 12$
; ───────────────────────────────────────────────────────────────────────────
; динамические спецэффекты - падающие точки и волны на буквах
                mov     #77500, @#SplTmp1
                mov     #160000, @#SplTmp2
                mov     #NoCoProgrSpl, R5   ; обойдёмся без музыки

13$:            mov     #StarsSplash, R0 ; адрес для откуда брать псевдослучайные значения
                mov     #200, R1        ; количество точек

14$:            mov     (R0)+, R2
                swab    R2
                call    (R5)
                sub     (R0)+, R2
                com     R2
                add     (R0)+, R2
                add     @#SplTmp2, R2
                bic     #160000, R2     ; получаем случайное число
                add     #40000, R2      ; формируем адрес экрана
                cmp     #56000, R2      ; если получилось больше, чем надо
                ble     19$             ; пропустим
                call    (R5)
                mov     R2, R3
                cmp     #41000, R3      ; если получилось меньше, чё надо
                ble     15$
                bic     #177701, R3     ; ещё проверяем
                beq     19$             ; и если что-то не так - пропустим

15$:            movb    (R2), R3        ; что там на экране?
                beq     17$             ; пусто - переход
                bic     #14, R3         ; очистим место под точку
                bne     19$             ; если там что-то есть, то пропустим
                cmp     #55700, R2      ; до низа дошли?
                ble     16$             ; да
                tstb    100(R2)         ; нет, а там есть препятствие?
                bne     16$             ; да
                movb    (R2), 100(R2)   ; нет - опускаем точку на строку ниже

16$:            clrb    (R2)            ; гасим точку
                br      19$             ; идём к следующей
; ───────────────────────────────────────────────────────────────────────────

17$:            call    (R5)
                add     R2, @#RndBuff
                call    @#RND           ; Генерация случайного числа.
                                        ; Выход: R3 - число
                bic     #177763, R3     ; получим точку случайного цвета
                bne     18$             ; если есть цвет, то хорошо
                mov     #14, R3         ; если нет - то красный цвет

18$:            tstb    100(R2)         ; препятствие есть?
                bne     19$             ; да - не рисуем
                movb    R3, 100(R2)     ; нет - рисуем

19$:            sob     R1, 14$         ; рандомные звёзды
                add     #100, @#SplTmp2 ; далее - спецэффект с буквами
                bne     20$
                mov     #160000, @#SplTmp2

20$:            mov     @#SplTmp1, R0

21$:            mov     #40, R1

22$:            call    (R5)
                bic     #52525, (R0)+
                sob     R1, 22$
                add     #100, R0
                bmi     25$
                mov     #40, R1

23$:            ror     (R0)+
                sob     R1, 23$
                add     #100, R0
                bmi     25$
                mov     #40, R1

24$:            mov     (R0), R2
                rol     R2
                bis     R2, (R0)+
                sob     R1, 24$

25$:            call    (R5)
                add     #100, R0
                bpl     21$
                sub     #100, @#SplTmp1
                cmp     #73000, @#SplTmp1
                ble     26$
                add     #600, @#SplTmp1

26$:            bit     #100, @#177716  ; пока не нажмём клавишу - визуальные эффекты
                bne     13$
                jmp     @#GameMenu
; End of function EntryPoint


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вход: R0 - адрес экрана
;       R1 - номер точки в байте, с которого начинается вывод
;       R3 - битовая маска
;       R4 - адрес массива данных

DrawFigure:     movb    (R4)+, R2       ; берём очередной байт данных,
                                        ; это - длина горизонтальной линии в цветных точках
                bge     1$              ; эти две команды
                add     #400, R2        ; эквивалент bic #177400,R2

1$:             bicb    ClearMask(R1), (R0) ; рисуем в первом байте
                movb    ClearMask(R1), R5
                bic     R3, R5
                bisb    R5, (R0)+
                sub     #4, R2          ; в байте 4 точки
                add     R1, R2          ; в R1 - номер точки в байте, с которого начинается вывод
                blt     3$
                clr     R1

2$:             cmp     #4, R2          ; можем нарисовать сразу 4 точки (байт)?
                bgt     4$              ; нет
                movb    R3, (R0)        ; да - рисуем
                comb    (R0)+
                sub     #4, R2          ; вычитаем нарисованное
                br      2$              ; пойдём проверим
; ───────────────────────────────────────────────────────────────────────────

3$:             mov     R2, R1
                add     #4, R1
                dec     R0
                br      5$
; ───────────────────────────────────────────────────────────────────────────

4$:             bisb    SetMask(R2), (R0) ; рисуем в остаточном байте
                bicb    R3, (R0)
                mov     R2, R1

5$:             movb    (R4)+, R2       ; берём смещение от текущего положения
                beq     NoCoProgrSpl    ; конец массива
; End of function DrawFigure


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вход: R0 - адрес экрана
;       R1 - номер точки в байте, с которого начинается вывод
;       R2 - биты 7..2 - смещение к адресу в R0, биты 1..0 - приращение к R1
;       R3 - битовая маска
;       R4 - адрес массива данных

DrawFigure$2:   bge     1$              ; для этой точки входа эта команда будет всегда делать переход
                add     #400, R2        ; эквивалент bic #177400,R2

1$:             mov     R2, R5
                asr     R5
                asr     R5
                add     R5, R0          ; R0 += (R2 / 4)
                asl     R5
                asl     R5
                sub     R5, R2          ; R2 -= (R2 & 177774) эквивалентно R2 &=3
                add     R2, R1
                cmp     #4, R1
                bgt     2$
                sub     #4, R1
                inc     R0

2$:             br      DrawFigure
; End of function DrawFigure$2
; ───────────────────────────────────────────────────────────────────────────

NoCoProgrSpl:   return                  ; заглушка для сопрограммы музыки

; ───────────────────────────────────────────────────────────────────────────
; спрайт кокоса
Kokos:          .word ^B0101011111010101
                .word ^B0101110101110101
                .word ^B0101010101010101
                .word ^B0111010101011101
                .word ^B0101011111010101
                .word ^B0111010101011101
                .word ^B1101010101010111
                .word ^B0101110101110101
                .word ^B1101011111010111
                .word ^B0101010101010101
                .word ^B1101010101010111
                .word ^B0111011111011101

PyramidAddr:    .word 53402             ; Адреса вывода пирамид в заставке
                .word 53042
                .word 53070
                .word 53234
                .word 53122

PalmBodySection:.byte 10                ; секция ствола пальмы
                .byte 370, 10
                .byte 370, 10
                .byte 370, 10
                .byte 371, 6
                .byte 372, 6
                .byte 372, 6
                .byte 372, 6
                .byte 373, 4
                .byte 374, 4
                .byte 0

PalmBodyCoords: .byte 1                 ; Координаты ствола пальмы, 0 - конец
                .byte 371
                .byte 372
                .byte 373
                .byte 372
                .byte 373
                .byte 373
                .byte 372
                .byte 371
                .byte 371
                .byte 371
                .byte 372
                .byte 372
                .byte 0

SetMask:        .byte ^B00000000, ^B00000011, ^B00001111, ^B00111111
ClearMask:      .byte ^B11111111, ^B11111100, ^B11110000, ^B11000000

; пара: длина в точках, смещение до следующей линии
PalmCrown:      .byte 6, 372            ; Крона пальмы
                .byte 11, 367
                .byte 13, 366
                .byte 14, 364
                .byte 15, 364
                .byte 15, 363
                .byte 16, 362
                .byte 17, 362
                .byte 17, 361
                .byte 20, 360
                .byte 20, 361
                .byte 20, 360
                .byte 20, 17
                .byte 10, 331
                .byte 21, 13
                .byte 17, 326
                .byte 20, 10
                .byte 25, 323
                .byte 21, 6
                .byte 30, 321
                .byte 21, 4
                .byte 34, 317
                .byte 21, 2
                .byte 40, 316
                .byte 63, 302
                .byte 7, 5
                .byte 64, 276
                .byte 103, 273
                .byte 71, 7
                .byte 5, 271
                .byte 67, 307
                .byte 66, 311
                .byte 65, 312
                .byte 65, 312
                .byte 65, 312
                .byte 65, 312
                .byte 66, 311
                .byte 66, 311
                .byte 67, 311
                .byte 73, 305
                .byte 10, 7
                .byte 57, 302
                .byte 4, 17
                .byte 55, 326
                .byte 54, 323
                .byte 57, 321
                .byte 60, 317
                .byte 62, 316
                .byte 63, 314
                .byte 65, 313
                .byte 66, 311
                .byte 15, 5
                .byte 46, 310
                .byte 13, 10
                .byte 13, 10
                .byte 23, 306
                .byte 12, 13
                .byte 12, 13
                .byte 21, 305
                .byte 11, 14
                .byte 13, 15
                .byte 16, 304
                .byte 11, 16
                .byte 12, 17
                .byte 14, 304
                .byte 10, 17
                .byte 12, 21
                .byte 13, 303
                .byte 7, 21
                .byte 11, 22
                .byte 12, 302
                .byte 7, 22
                .byte 11, 23
                .byte 12, 301
                .byte 6, 24
                .byte 10, 25
                .byte 10, 301
                .byte 6, 24
                .byte 10, 26
                .byte 7, 301
                .byte 5, 26
                .byte 7, 27
                .byte 7, 277
                .byte 6, 26
                .byte 7, 30
                .byte 6, 277
                .byte 5, 27
                .byte 7, 30
                .byte 6, 277
                .byte 5, 30
                .byte 5, 32
                .byte 5, 277
                .byte 4, 31
                .byte 5, 33
                .byte 5, 276
                .byte 4, 31
                .byte 5, 34
                .byte 4, 276
                .byte 3, 33
                .byte 3, 35
                .byte 4, 276
                .byte 3, 33
                .byte 3, 36
                .byte 3, 276
                .byte 2, 34
                .byte 1, 40
                .byte 3, 276
                .byte 2, 34
                .byte 1, 41
                .byte 2, 0


                .END
